#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

vector<int> Fr;
vector<int> To;

struct query {
	int eid;
	int tp; //0 - rem, 1 add, 2 query
	query() {}
	query(int eid, int tp):eid(eid),tp(tp) {}
};

vector<int> ans;

vector<query> q;
vector<int> nxt;

int n;
struct T {
	vector<int> a;
	vector<pii> rev;
	T() {}
	T(int n) {
		a.resize(n);
	}
	void setval(int pos, int val) {
		rev.pb(mp(pos,a[pos]));
		a[pos] = val;
	}
	int getval(int pos) {
		return a[pos];
	}
	void rollback(int t) {
		while (sz(rev) > t) a[rev.back().X] = rev.back().Y, rev.pop_back();
	}
	int gettime() {
		return sz(rev);
	}
};


T P;
T C;

int findset(int x) {
	if (P.getval(x) == x) return x;
	int r = findset(P.getval(x));
	P.setval(x, r);
	return r;
}

void unite(int x, int y) {
	x = findset(x);
	y = findset(y);
	if (x != y) {
		C.setval(x, C.getval(x)+C.getval(y));
		P.setval(y, x);
	}
}

void solve(int l, int r, const vector<int>& queries) {
	if (l == r) {
		if (q[l].tp == 2) {
			ans[q[l].eid] = C.getval(findset(0)) == n;
		}
		return;
	} else {
		int m = (l+r)>>1;
		forn(iter, 2) {
			int fr = l;
			int to = m;
			if (iter) fr = m+1, to = r;
			int tm1 = P.gettime();
			int tm2 = C.gettime();
			vector<int> tq;
			forn(ii, sz(queries)) {
				int qid = queries[ii];
				int st = qid;
				int en = nxt[qid];
				if (st < fr && en > to) {
					int eid = q[qid].eid;
					unite(Fr[eid], To[eid]);
				} else if (st >= fr && st <= to || en >= fr && en <= r) tq.pb(qid);
			}
			solve(fr, to, tq);
			P.rollback(tm1);
			C.rollback(tm2);
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int m; scanf("%d%d", &n, &m);
	Fr.resize(m);
	To.resize(m);
	forn(i, m) scanf("%d%d", &Fr[i], &To[i]), --Fr[i], --To[i];
	
	forn(i, m) q.pb(query(i, 1));
	int k; scanf("%d", &k);
	forn(iter, k) {
		int c; scanf("%d", &c);
		vector<int> ids;
		forn(j, c) {
			int id; scanf("%d", &id); --id;
			ids.pb(id);
			q.pb(query(id, 0));
		}
		q.pb(query(iter, 2));
		forn(ii, sz(ids)) q.pb(query(ids[ii], 1));
	}
	ans.resize(k);
	nxt = vector<int>(sz(q), sz(q));
	vector<int> lst(m,sz(q));
	for (int i = sz(q)-1; i >= 0; --i) {
		if (q[i].tp == 2) nxt[i] = i;
		else if (q[i].tp == 0) {
			nxt[i] = -1;
			lst[q[i].eid] = i;
		} else if (q[i].tp == 1) nxt[i] = lst[q[i].eid];
	}
	P = T(n);
	C = T(n);
	forn(i, n) P.a[i] = i;
	forn(i, n) C.a[i] = 1;
	vector<int> qqq;
	forn(i, sz(q)) if (q[i].tp != 0) qqq.pb(i);
	solve(0,sz(q)-1, qqq);
	forn(i, sz(ans)) {
		if (ans[i]) printf("Connected\n");
		else printf("Disconnected\n");
	}
	return 0;
}
