#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
#define fname "disconnected."
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e5 + 100;
const int inf = (1 << 30) - 1;
const int magic = 500;
const int Bit = 61;

int n, R, v, u, k, c, pr[maxn], h[maxn], bad[maxn], ti, cnt, d[maxn], m[maxn];
pair <pair<int, int>, int> s[maxn];
LL was[1001][maxn / Bit];     

int Find(int v)
{
	if (pr[v] == v)
		return v;
	return pr[v] = Find(pr[v]);
}

void Union(int v, int u)
{
	v = Find(v);
	u = Find(u);
	if (h[v] > h[u])
		pr[u] = v;
	else
	{
		pr[v] = u;
		h[u] = max(h[v] + 1, h[u]);
	}
}

int main()
{
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> R;
	for (int i = 0; i < R; i++)
	{
		cin >> v >> u;
		s[i] = mp(mp(u, v), i);
	}

	for (int i = 0; i < maxn; ++i)
		d[i] = i / Bit, m[i] = i % Bit;

	for (int T = 1; T <= magic; T++)
	{
		random_shuffle(s, s + R);
		for (int i = 1; i <= n; i++)
			pr[i] = i, h[i] = 0;
		for (int i = 0; i < R; ++i)
		{
			if (Find(s[i].F.F) != Find(s[i].F.S))
			{
				Union(s[i].F.F, s[i].F.S);
				was[T][d[s[i].S]] |= (1ll << m[s[i].S]);
			}
		}
	}
	cin >> k;
	while (k--)
	{     
		cin >> c;
		++ti;
		cnt = 0;
		for (int j = 1; j <= c; j++)
		{
			cin >> v;
			v--;
			for (int i = 1; i <= magic; i++)
			{
				if (bad[i] != ti && (was[i][d[v]] & (1ll << m[v])))
				{
					bad[i] = ti;
					cnt++;
				}
			}
	  	}
	  	if (cnt == magic)
  			cout << "Disconnected\n";
  	  	else
  	  		cout << "Connected\n";
  	}
	
	return 0;
}
