#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <ctime>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define MAXN 200002
#define f first
#define s second

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

int n, m;
pair <int, int> e[MAXN];
vector < pair<int, int> > g[MAXN];
vector <int> clear;
int a[MAXN];
int c[MAXN];
int d[MAXN];
int dd;
int cc;
int color[N],up[N],colors;
bool bridge[N];
int w1[MAXN];
int w2[MAXN];

void dfs(int v, int pr_edge, int lvl) {
	d[v] = lvl;
	up[v] = n+1;
	for (int i = 0; i < sz(g[v]); i++) {
		int u = g[v][i].first;
		int edge = g[v][i].second;
		if (edge == pr_edge) continue;
		if (!d[u]) {
			dfs(u, edge, lvl + 1);
			up[v] = min(up[v], up[u]);
			if (d[v] < up[u]) bridge[edge] = 1;
		} else {
			up[v] = min(up[v], d[u]);
		}
	}
}

void dfs2(int v, int c) {
	color[v] = c;
	for (int i = 0; i < sz(g[v]); i++) {
		int u = g[v][i].f;
		if (!color[u])
			dfs2(u, c);
	}
}


inline bool in(int id)
{
	for (int i = 0; i < sz(clear); ++i)
		if (clear[i] == id)
			return 1;
	return 0;
}

int dfss(int v)
{
	c[v] = cc;
	int r = 1;
	for (int i = 0; i < sz(g[v]); ++i)
	{
		int v2 = g[v][i].f;
		int id = g[v][i].s;
		if (c[v2] != cc && !in(id))
		{
			d[id] = dd;
			r += dfss(v2);
		}
	}
	return r;
}


int dfss2(int v)
{
	c[v] = cc;
	int r = 1;
	for (int i = 0; i < sz(g[v]); ++i)
	{
		int v2 = g[v][i].f;
		int id = g[v][i].s;
		if (c[v2] != cc && !in(id))
			r += dfss2(v2);
	}
	return r;
}


int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	double begin = clock();

	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i)
	{
		int v1, v2;
		scanf("%d%d", &v1, &v2);
		--v1, --v2;
		g[v1].pb(mp(v2, i));
		g[v2].pb(mp(v1, i));
		e[i] = mp(v1, v2);
	}

	dfs(1, 0, 1);
	for (int i = 0; i < n; i++)
		if (!color[i])
			dfs2(i, ++colors);

	int q;
	scanf("%d", &q);
	dd = 1;
	++cc;
	bool ok = dfss(0) == n;
	for (int i = 0; i < q; ++i)
	{
		int t;
		scanf("%d", &t);
		for (int j = 0; j < t; ++j)
		{
			scanf("%d", &a[j]);
			--a[j];
		}

		bool mark = 0;
		for (int j = 0; j < t; ++j)
			if (bridge[a[j]])
				mark = 1;

		if (mark)
		{
			puts("Disconnected");
			for (int j = 0; j < t; ++j)
				--w1[a[j]];
			continue;
		}
		int v = -1;
		for (int j = 0; j < t; ++j)
			if (d[a[j]] == 1)
				v = e[a[j]].f;
		++cc;
		if (v == -1)
		{
			for (int j = 0; j < t; ++j)
				++w2[a[j]];
			puts(ok ? "Connected" : "Disconnected");
		}
		else
		{
			clear.clear();
			for (int j = 0; j < t; ++j)
				clear.pb(a[j]);
			bool okek = 1;
			if ((clock() - begin) / CLOCKS_PER_SEC > 1.5)
			{
				int t = 0;
				for (int j = 0; j < t; ++j)
					if (w2[a[j]] >= 10)
						++t;
					else
						--t;
				puts(t >= 2 ? "Connected" : "Disconnected");
					
				continue;
			}
			for (int j = 0; j < t; ++j)
				if (w2[a[j]] <= max(20, m / 10000))
					okek = 0;
			if (okek)
			{
				puts(okek ? "Connected" : "Disconnected");
				continue;
			}
			bool oke = dfss2(v) == n;
			puts(oke ? "Connected" : "Disconnected");
			for (int j = 0; j < t; ++j)
				if (oke)
					++w2[a[j]];
				else
					--w1[a[j]];
		}
	}

	return 0;
}
