#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

int n,m,ans,color[N],d[N],up[N],colors,a[N],b[N];
vector<pii> e[N];
bool bridge[N];
vi g[N];

void dfs(int v, int pr_edge, int lvl) {
	d[v] = lvl;
	up[v] = n+1;
	for (int i = 0; i < sz(e[v]); i++) {
		int u = e[v][i].first;
		int edge = e[v][i].second;
		if (edge == pr_edge) continue;
		if (!d[u]) {
			dfs(u, edge, lvl + 1);
			up[v] = min(up[v], up[u]);
			if (d[v] < up[u]) bridge[i] = 1;
		} else {
			up[v] = min(up[v], d[u]);
		}
	}
}

void dfs2(int v, int c) {
	color[v] = c;
	for (int i = 0; i < sz(g[v]); i++) {
		int u = g[v][i];
		if (!color[u])
			dfs2(u, c);
	}
}

int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; i++) {
		scanf("%d %d", a+i, b+i);
		e[a[i]].pb(mp(b[i], i));
		e[b[i]].pb(mp(a[i], i));
	}
	dfs(1, 0, 1);
	for (int i = 0; i < m; i++) {
		if (bridge[i]) continue;
		g[a[i]].pb(b[i]);
		g[b[i]].pb(a[i]);
	}
	for (int i = 1; i <= n; i++)
	if (!color[i])
		dfs2(i, ++colors);
	int q, a1, a2, b1, b2;
	scanf("%d %d %d", &q, &a1, &b1);
	for (int i = 0; i < n; i++) {
		if (color[a[i]] == color[b[i]]) ans++;
		a2 = b1;
		b2 = (13579ll*a1 + 97531ll*b1) % n + 1;
		a1 = a2;
		b1 = b2;
	}
	cout << ans;
	return 0;
}
