#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "a"

const int maxn = 300000;
const int maxm = 300000;

int n, m, used[maxn];
pair<int, int> edges[maxn];
ll value[maxm], subtree[maxn];
vector<int> g[maxn];

ll rand64()
{
	return ((ll) rand() << 32) | rand();
}

ll dfs(int v, int p)
{
	used[v] = 1;
	subtree[v] = 0;
	for (int id : g[v])
	{
		auto e = edges[id];
		if (e.first != v) swap(e.first, e.second);
		if (e.se == p) continue;
		if (used[e.se] == 1)
		{
			value[id] = rand64();
			subtree[v] ^= value[id];
			subtree[e.se] ^= value[id];
		}
		else if (used[e.se] == 0)
		{
			ll x = dfs(e.se, v);
			//cerr << v << " " << p << " " << id << " Ret " << x << endl;
			value[id] = x;
			subtree[v] ^= x;
		}
	}
	used[v] = 2;
	return subtree[v];
}

bool test(const vector<int> &edges)
{
	for (int msk = 1; msk < (1 << edges.size()); ++msk)
	{
		ll x = 0;
		for (size_t i = 0; i < edges.size(); ++i)
			if ((msk >> i) & 1) x ^= value[edges[i]];
		if (x == 0) return true;
	}
	return false;
}

void solve()
{
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i)
	{
		scanf("%d%d", &edges[i].fi, &edges[i].se);
		edges[i].fi--;
		edges[i].se--;
		g[edges[i].fi].pb(i);
		g[edges[i].se].pb(i);
	}
	dfs(0, -1);
//	for (int i = 0; i < m; ++i)
//		cerr << value[i] << " ";
//	cerr << endl;
	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; ++i)
	{
		int t;
		scanf("%d", &t);
		vector<int> v(t);
		for (int j = 0; j < t; ++j)
			scanf("%d", &v[j]), v[j]--;
		if (test(v)) printf("Disconnected\n");
		else printf("Connected\n");
	}
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	solve();
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
