#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME "disconnected"

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	freopen(FILENAME ".in", "r", stdin);
	freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int dsu[101010];

int get(int a) 
{
	if(dsu[a] == a)
		return a;
	return dsu[a] = get(dsu[a]);
}

void unite(int a, int b){ 
	a = get(a);
	b = get(b);
	dsu[a] = b;
}

int found = 0;
int TIMER = 1;

int used[101010];


void dfs(int v, const vi& query, const vector<vector<pi>>& g) {
	if(used[v] == TIMER)
		return;
	used[v] = TIMER;
	++found;
	for(int i = 0; i < g[v].size(); ++i) {
		if(find(all(query), g[v][i].second) == query.end()) {
			dfs(g[v][i].first, query, g);
		}
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<pi> edges(m);
	for(int i = 0; i < m; ++i) {
		cin >> edges[i].first >> edges[i].second;
		--edges[i].first, --edges[i].second;
	}


	int q;
	cin >> q;
	vector<vi> queries;
	const int MAGIC = 1000;
	for(int it = 0, groups = (q + (MAGIC - 1) / MAGIC ); it < groups; ++it) {
		queries.clear();
		queries.reserve(MAGIC);
		vector<int> used_edges(m);
		
		for(int j = MAGIC * it; j < MAGIC * (it + 1) && j < q; ++j) {
			int k;
			cin >> k;
			queries.push_back(vi(k));
			for(int t = 0; t < k; ++t) {
				cin >> queries.back()[t];
				--queries.back()[t];
				used_edges[queries.back()[t]] = 1;
			}
		}

		for(int i = 0; i < n; ++i) {
			dsu[i] = i;
		}


		for(int i = 0; i < m; ++i) {
			if(!used_edges[i]) {
				unite(edges[i].first, edges[i].second);
			}
		}

		vector<vector<pi>> g(n);

		for(int i = 0; i < m; ++i) {
			if(used_edges[i]) {
				g[get(edges[i].first)].push_back(mp(get(edges[i].second), i));
				g[get(edges[i].second)].push_back(mp(get(edges[i].first), i));
			}
		}
		int needCnt = 0;
		for(int i = 0; i < n; ++i) {
			if(get(i) == i) {
				++needCnt;
			}
		}
		for(int i = 0; i < queries.size(); ++i) {
			found = 0;
			++TIMER;
			dfs(get(0), queries[i], g);
			//cout << found << ' ' << needCnt << endl;
			if(found == needCnt) {
				cout << "Connected\n";
			}
			else {
				cout << "Disconnected\n";
			}
		}
	}
}