#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME "disconnected"

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(FILENAME ".in", "r", stdin);
	freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cerr << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int dsu[101010];

inline int get(int a) 
{
	if(dsu[a] == a)
		return a;
	return dsu[a] = get(dsu[a]);
}

void unite(int a, int b){ 
	a = get(a);
	b = get(b);
	dsu[a] = b;
}

int smalldsu[101010];

inline int smallget(int a) 
{
	if(smalldsu[a] == a)
		return a;
	return smalldsu[a] = smallget(smalldsu[a]);
}

void smallunite(int a, int b){ 
	a = smallget(a);
	b = smallget(b);
	smalldsu[a] = b;
}

int TIMER = 1;
	
int used_edges[101010];
int current_edges[101010];



pi edges[101010];

vi cedges;

int ids[101010];

void solve() {
	int n, m;
	//cin >> n >> m;
	scanf("%d %d", &n, &m);
	for(int i = 0; i < m; ++i) {
		scanf("%d %d", &edges[i].first , &edges[i].second);
		//cin >> edges[i].first >> edges[i].second;
		--edges[i].first, --edges[i].second;
	}


	int q;
	//cin >> q;
	scanf("%d", &q);
	vector<vi> queries;
	const int MAGIC = 400;


	for(int it = 0, groups = ((q + (MAGIC - 1)) / MAGIC ); it < groups; ++it) {
		//cerr << it << endl;
		queries.clear();
		cedges.clear();
		queries.reserve(MAGIC);
		
		for(int j = MAGIC * it; j < MAGIC * (it + 1) && j < q; ++j) {
			int k;
			//cin >> k;
			scanf("%d", &k);
			queries.push_back(vi(k));
			for(int t = 0; t < k; ++t) {
				//cin >> queries.back()[t];
				scanf("%d", &queries.back()[t]);
				--queries.back()[t];
				used_edges[queries.back()[t]] = TIMER;
			}
		}

		for(int i = 0; i < n; ++i) {
			dsu[i] = i;
		}


		for(int i = 0; i < m; ++i) {
			if(used_edges[i] != TIMER) {
				unite(edges[i].first, edges[i].second);
			}
			else
				cedges.push_back(i);
		}

		int cnt = 0;

		

		//cout << cnt << "\n";
	
		for(int i = 0; i < n; ++i) {
			if(dsu[i] == i) {
				ids[i] = cnt++;
			}
		}


		

		
		for(int i = 0; i < queries.size(); ++i) {
			++TIMER;

			for(int i = 0; i < cnt; ++i) {
				smalldsu[i] = i;
			}

			for(int j = 0; j < queries[i].size(); ++j) {
				current_edges[queries[i][j]] = TIMER;
			}


			for(int j = 0; j < cedges.size(); ++j) {
				int cur = cedges[j];
				if(current_edges[cur] != TIMER) {
				//	cout << "edge" << edges[cur].first << ' ' << edges[cur].second << "\n";
				//	cout << "comp" << get(edges[cur].first) << ' ' << get(edges[cur].second)<< "\n";
				//	cout << "nums " << ids[get(edges[cur].first)] << ' ' << ids[get(edges[cur].second)] << "\n";

					
					smallunite(ids[get(edges[cur].first)], ids[get(edges[cur].second)]);
		
				}
			}
		

			bool ok = true;

			


			for(int i = 1; i < cnt; ++i )
			{
				if(smallget(i) != smallget(0)) {
					ok = false;
					break;
				}
			}
			//cout << found << ' ' << needCnt << endl;
			if(ok) {
				printf("Connected\n");
			}
			else {
				printf("Disconnected\n");
			}
		}
	}
}