#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int n, m;
vector <vector <int> > g;
int TIMER = 1;
vector <int> isP;
vector <int> color;
vector <int> tin, fup;
int TIMER2 = 0;

void dfs(int v, int par = -1) {
	color[v] = TIMER;

	++TIMER2;
	tin[v] = fup[v] = TIMER2;

	int children = 0;

	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];

		if (to == par) {
			continue;
		}

		if (!color[to]) {
			++children;
			dfs(to, v);
			fup[v] = min(fup[v], fup[to]);
			if (par != -1 && fup[to] >= tin[v]) {
				isP[v] = 1;
			}
		}
		else {
			fup[v] = min(fup[v], tin[to]);
		}
	}

	if (par == -1 && children > 1) {
		isP[v] = 1;
	}
}

vector < vector <int> > comps;
int compNum = 0;
vector <int> used;

void dfs2(int v, vector <int>& st, int par = -1) {
	used[v] = TIMER;

	st.push_back(v);


	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];

		if (used[to] == TIMER) {
			continue;
		}

		if (isP[v] && fup[to] >= tin[v] || par == -1) {
			dfs2(to, st, v);
			++compNum;
			while (st.back() != v) {
				comps[st.back()].push_back(compNum - 1);
				st.pop_back();
			}
			comps[v].push_back(compNum - 1);
		}

	}

	for (int i = 0; i < g[v].size(); ++i) {
		int to = g[v][i];

		if (used[to] == TIMER) {
			continue;
		}

		dfs2(to, st, v);

	}
	
}

vector <vector <int> > g2;
vector <int> parents;


void dfs3(int v, int par = -1) {
	parents[v] = par;
	for (int i = 0; i < g2[v].size(); ++i) {
		int to = g2[v][i];
		if (to == par) {
			continue;
		}
		dfs3(to, v);
	}
}

void build() {
	g2.resize(n + compNum);
	parents.assign(n + compNum, -2);

	for (int i = 0; i < n; ++i) {
		if (isP[i]) {
			for (int j = 0; j < comps[i].size(); ++j) {
				g2[i].push_back(n + comps[i][j]);
				g2[comps[i][j] + n].push_back(i);
			}
		}
	}
	for (int i = 0; i < compNum; ++i) {
		if (parents[n + i] == -2) {
			dfs3(n + i);
		}
	}
}

int solve(int x, int y) {
	if (x == y) {
		return 1;
	}

	if (color[x] != color[y]) {
		return 0;
	}
	if (comps[x].size() > comps[y].size()) {
		swap(x, y);
	}
	if (comps[x].size() == 1 && comps[y].size() == 1) {
		return comps[x][0] == comps[y][0];
	}

	assert(isP[x] || isP[y]);

	if (!isP[x])
		x = comps[x][0] + n;

	if (!isP[y])
		y = comps[y][0] + n;

	if (parents[x] == y)
		return true;
	if (parents[y] == x)
		return true;

	if (parents[x] >= 0 && parents[y] >= 0 && parents[x] == parents[y])
		return true;

	for (int w = 0; w < 2; ++w) {
		if (parents[x] >= 0) {
			int z = parents[x];
			if (parents[z] == y)
				return true;
		}
		swap(x, y);
	}

	return false;
}

void solve() {
	cin >> n >> m;
	g.resize(n);
	isP.assign(n, 0);
	tin.assign(n, -1);
	fup.assign(n, -1);
	comps.resize(n);

	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		--x;
		--y;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	color.resize(n);
	used.resize(n);

	for (int i = 0; i < n; ++i) {
		if (!color[i]) {
			++TIMER;
			dfs(i);
		}
	}


	++TIMER;

	
	for (int i = 0; i < n; ++i) {
		if (used[i] != TIMER) {
			vector <int> tmp;
			dfs2(i, tmp);
		}
	}

	build();

	int q;
	int qq[2];

	cin >> q >> qq[0] >> qq[1];



	int ans = 0;

	/*
	for (int i = 0; i < n; ++i) {
		cerr << isP[i] << " ";	
	}
	cerr << endl;
	*/


	/*for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			cout << i + 1 << ' ' << j + 1 << ' ' << solve(i, j) << "\n";
	return;
	*/
	for (int i = 0; i < q; ++i) {
		int last = ans;
		ans += solve(qq[0] - 1, qq[1] - 1);
		
		//cerr << qq[0] << " " << qq[1] << " " << ans - last << endl;

		qq[0] = ((13579LL * qq[0] + 97531LL * qq[1]) % n) + 1;
		swap(qq[0], qq[1]);	
	}

	cout << ans << endl;
}