#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>

inline li lirand() {
	li a = rand(), b = rand(), c = rand(), d = rand();
	return (a << 48) + (b << 32) + (c << 16) + d;
}

int n, m;
vector<int> g[100100];
vector<int> num[100100];
li color[100100];
bool colored[100100];
bool used[100100];

li dfs(int v, int pred = -1) {
	used[v] = true;
	li cur_xor = 0;
	for (int i = 0; i < (int)g[v].size(); i++) {
		int to = g[v][i];
		int number = num[v][i];
		if (to == pred)
			continue;
		if (used[to]) {
			if (colored[number]) {
				cur_xor ^= color[number];
			} else {
				colored[number] = true;
				color[number] = lirand();
				cur_xor ^= color[number];
			}
		} else {
			li res = dfs(to, v);
			colored[number] = true;
			color[number] = res;
			cur_xor ^= res;
		}
	}
	return cur_xor;
}

int main()
{
	srand(43);
	freopen("disconnected.in", "r", stdin);
	freopen("disconnected.out", "w", stdout);
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		g[u].push_back(v);
		g[v].push_back(u);
		num[v].push_back(i);
		num[u].push_back(i);
	}
	dfs(0);
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int cnt;
		cin >> cnt;
		int res = 0;
		for (int j = 0; j < cnt; j++) {
			int v;
			cin >> v;
			v--;
			res ^= color[v];
		}
		if (res) 
			cout << "Connected\n";
		else
			cout << "Disconnected\n";
	}
}