#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <string>
#include <vector>
#include <memory.h>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fi first
#define se second
#define pii pair <int, int>
#define mp make_pair
#define i64 long long
#define li long long
#define vi vector <int>
#define pb push_back

const int maxn = 1e5 + 5;

bool mark[maxn];
int t_in[maxn];
vi edges[maxn];
int T;
int f[maxn];
bool cut_point[maxn];
vector<int> num[maxn];
int color[maxn];

void dfs(int v, int anc)
{
	T++;
	t_in[v] = f[v] = T;
	mark[v] = true;
	int cnt = 0;
	cut_point[v] = false;
	forn(j, edges[v].size())
	{
		int u = edges[v][j];
		if (u == anc)
			continue;
		if (mark[u])
			f[v] = min(f[v], t_in[u]);
		else
		{
			cnt++;
			dfs(u, v);
			f[v] = min(f[v], f[u]);
			if (f[u] >= t_in[v])
			{
				cut_point[v] = true;
			}
		}
	}
	if (anc == -1)
		cut_point[v] = (cnt > 1);
}

bool used[maxn];
int cur_col = 1;

void dfs2(int v, int col) {
	used[v] = true;
	for (int i = 0; i < (int)edges[v].size(); i++) {
		int to = edges[v][i];
		int number = num[v][i];
		if (cut_point[v]) {
			if (f[to] < t_in[v]) {
				if (color[number] == -1)
					color[number] = col;
				if (!used[to])
					dfs2(to, col);
			} else {
				if (color[number] == -1) {
					color[number] = cur_col;
					cur_col++;
				}
				if (!used[to])
					dfs2(to, color[number]);
			}
		} else {
			if (color[number] == -1)
				color[number] = col;
			if (!used[to])
				dfs2(to, col);
		}
	}
}

int vert_color[maxn];
set<int> cut_colors[maxn];
set<int> down[maxn];
vector<int> colors[maxn * 10];

int dfs3(int v) {
	used[v] = true;
	int res = -1;
	for (int i = 0; i < (int)edges[v].size(); i++) {
		int to = edges[v][i];
		if (used[to])
			continue;
		res = dfs3(to);
		if (cut_point[v])
			down[v].insert(res);
	}
	if (cut_point[v])
		return v;
	else
		return res;
}

vi G[maxn * 10];
bool Gwas[maxn * 10];
pii p[maxn * 10];

void go(int v, int anc, int grandanc)
{
	Gwas[v] = true;
	p[v] = mp(anc, grandanc);
	forn(j, G[v].size())
	{
		int u = G[v][j];
		if (!Gwas[u])
		{
			go(u, v, anc);
		}
	}
}

void invoke(int n)
{
	for (int c = 1; c < cur_col; c++)
	{
		forn(j, colors[c].size())
		{
			G[c + n].pb(colors[c][j]);
			G[colors[c][j]].pb(c + n);
		}
	}
	memset(Gwas, false, sizeof(Gwas));
	for (int j = 1; j < n + cur_col; j++)
		if (!Gwas[j])
			go(j, -1, -1);
}

int main()
{
	freopen("code.in", "r", stdin);
	freopen("code.out", "w", stdout);
	int n, m;
	memset(color, 255, sizeof(color));
	scanf("%d%d", &n, &m);
	forn(j, m)
	{
		int fr, to;
		scanf("%d%d", &fr, &to);
		edges[fr].pb(to);
		num[fr].push_back(j);
		edges[to].pb(fr);
		num[to].push_back(j);
	}
	T = 0;
	fore(j, 1, n)
		if (!mark[j])
			dfs(j, -1);


	/*for (int i = 1; i <= n; i++) {
		cerr << cut_point[i] << ' ' ;
	}
	cerr << endl;*/

	for (int i = 1; i <= n; i++)
		if (!used[i])
			dfs2(i, 0);

	/*for (int i = 0; i < m; i++) {
		cerr << color[i] << ' ';
	}
	cerr << endl;*/

	memset(used, 0, sizeof(used));
	for (int i = 1; i <= n; i++) {
		if (!used[i])
			dfs3(i);
	}

	for (int i = 1; i <= n; i++) {
		if (cut_point[i]) {
			for (int j = 0; j < (int)edges[i].size(); j++) {
				int number = num[i][j];
				cut_colors[i].insert(color[number]);
			}
		} else {
			for (int j = 0; j < (int)edges[i].size(); j++) {
				int number = num[i][j];
				vert_color[i] = color[num[i][j]];
				break;
			}
		}
	}

	for (int i = 1; i <= n; i++) {
		if (cut_point[i]) {
			for (auto it = cut_colors[i].begin(); it != cut_colors[i].end(); it++) {
				colors[*it].push_back(i);
			}
		}
	}
	invoke(n);

	int Q, A, B;
	//scanf("%d", &Q);
	scanf("%d%d%d", &Q, &A, &B);
	int res = 0;
	forn(query, Q)
	{
		//scanf("%d%d", &A, &B);
		if (cut_point[A] && cut_point[B]) {
			if (p[A].se == B || p[B].se == A || p[A].first == p[B].fi)
				res++;
		} else if (cut_point[A]) {
			if (cut_colors[A].count(vert_color[B]) != 0)
				res++;
		} else if (cut_point[B]) {
			if (cut_colors[B].count(vert_color[A]) != 0)
				res++;
		} else {
			if (vert_color[A] == vert_color[B])
				res++;
		}
		//printf("res = %d\n", res);
		int newa = B;
		int newb = (13579 * A + 97531 * B) % n + 1;
		A = newa, B = newb;
	}
	printf("%d\n", res);
	//cerr << res << endl;
}