#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;
typedef vector<vi> vvi;

const int N = 100500;
vi g[N];
vector<vpi> comps;
vi inComps[N];
bool used[N];
int br[N];
int timer = 0;
int tin[N], fup[N];
vpi edges;
int parV[N];
int parC[N];

void dfs(int v, int p)
{
	tin[v] = fup[v] = timer++;
	used[v] = 1;
	for (int to: g[v])
	{
		if (to == p) continue;
		if (used[to])
			fup[v] = min(fup[v], tin[to]);
		else
		{
			edges.pb(mp(v, to));
			dfs(to, v);
			fup[v] = min(fup[v], fup[to]);
			if (fup[to] > tin[v])
			{
				br[to] = v;
			}
			if (fup[to] >= tin[v] || p == -1)
			{
				vpi cur;
				while (edges.back() != mp(v, to))
				{
					cur.pb(edges.back());
					edges.pop_back();
				}
				cur.push_back(edges.back());
				edges.pop_back();
				parC[comps.size()] = v;
				for (pii ed: cur)
					parV[ed.fi] = parV[ed.second] = comps.size();
				comps.push_back(cur);
			}
		}
	}
}

int f(int u, int v)
{
	forn (i, 2)
	{
		if (br[v] == u) return 0;
		swap(u, v);
	}
	if (parV[u] == parV[v]) return 1;
	forn (i, 2)
	{
		int x = parV[v];
		if (x >= 0 && parC[x] == u) return 1;
		swap(u, v);
	}
	return 0;
	/*
	if (inComps[u].size() > inComps[v].size())
		swap(u, v);
	if (inComps[u].size() == 1)
	{
		int p = inComps[u][0];
		return binary_search(all(comps[p]), v);
	}
	*/
}

int main() {
#define TASK "code"
#ifdef HOME
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	int n, m;
	scanf("%d%d", &n, &m);
	forn (i, n) br[i] = -1;
	forn (i, m)
	{
		int u, v;
		scanf("%d%d", &u, &v);
		--u, --v;
		g[u].pb(v);
		g[v].pb(u);
	}
	forn (i, n)
		if (!used[i])
		{
			dfs(i, -1);
			assert(edges.empty());
			parV[i] = -i-1;
		}
	forn (i, comps.size()) {
		sort(all(comps[i]));
		for (pii x: comps[i]) {
			inComps[x.fi].pb(i);
			inComps[x.se].pb(i);
		}
	}
	forn (i, n)
	{
		sort(all(inComps[i]));
		inComps[i].resize(unique(all(inComps[i])) - inComps[i].begin());
	}
	/*forn (i, n)
	{
		cerr << i << endl;
		for (int x: inComps[i]) cerr << x << " "; cerr << endl;
	}*/
	int A, B, Q;
	scanf("%d%d%d", &Q, &A, &B);
	int res = 0;
	forn (qq, Q)
	{
		res += f(A - 1, B - 1);
		int nA = B;
		int nB = (13579LL * A + 97531LL * B) % n + 1;
		A = nA;
		B = nB;
	}
	cout << res << "\n";
	return 0;
}
