#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
#include <queue>
#include <cstdio>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define all(x) x.begin(),x.end()

int n, m, q, a1, b1;

vector< vector<int> >g;
set< pair<int, int> > bad;

vector<int> tin, f;
vector<bool> used;
vector<int> comp;
vector<int> back;
int t = 0;

inline int F(int v, int p) {
	used[v] = true;
	f[v] = tin[v] = t++;

	for(int i = 0; i < g[v].size(); i++) {
		int u = g[v][i];
		if(used[u]) {
			if(u != p) f[v] = min(f[v], f[u]);
		}
	}

	for(int i = 0; i < g[v].size(); i++) {
		int u = g[v][i];
		if(!used[u]) {
			back[u] = v;
			f[v] = min(f[v], F(u, v));
		}
	}


	return f[v];
}

inline void dfs2(int v, int c) {
	used[v] = true;
	comp[v] = c;
	for(int i = 0; i < g[v].size(); i++) {
		int u = g[v][i];
		if(!used[u] && bad.find(mp(u,v)) == bad.end()) dfs2(u, c);
	}
}

inline void divide() {
	for(int v = 0; v < n; v++) {
		if(tin[v] == f[v]) {
			int u = back[v];
			if(u == -1) continue;
			bad.insert(mp(u, v));
			bad.insert(mp(v, u));
		}
	}
}

const int p1 = 100179, p2 = 100057, M1 = 100000007, M2 = 100000179;

bitset<M1> h1;
bitset<M2> h2;

inline int hash1(int u, int v) {
	return (1LL * u * p1 + v) % M1;
}

inline int hash2(int u, int v) {
	return (1LL * u * p2 + v) % M2;
}

int main()
{
	ios_base::sync_with_stdio(false);
	//freopen("kthstat.in", "r", stdin);
	//freopen("kthstat.out", "w", stdout);

	cin >>n >>m;
	used.assign(n, false);
	tin.resize(n);
	f.resize(n);
	back.assign(n, -1);
	g.assign(n, vector<int>());

	for(int i = 0; i < m; i++) {
		int u, v;
		cin >>u >>v;
		u--, v--;
		g[u].pb(v);
		g[v].pb(u);
		h1.set(hash1(u, v), true);
		h2.set(hash2(u, v), true);
		h1.set(hash1(v, u), true);
		h2.set(hash2(v, u), true);
	}

	for(int i = 0; i < n; i++) {
		if(!used[i]) F(i, -1);
	}

	divide();
	comp.resize(n);

	used.assign(n, false);
	int c = 0;
	for(int i = 0; i < n; i++) {
		if(!used[i]) dfs2(i, c++);
	}

	cin >>q >>a1 >>b1;
	int a = a1, b = b1;

	int ans = 0;
	for(int i = 0; i < q; i++) {
		int ra = a - 1, rb = b - 1;
		if(ra == rb || (h1[hash1(ra, rb)] && h2[hash2(ra, rb)]) || comp[ra] == comp[rb]) ans++;
		int _a = b, _b = (1LL * 13579 * a + 1LL * 97531 * b) % n + 1;
		a = _a, b = _b;
	}

	cout <<ans <<endl;

	return 0;
}