#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())

const int N = (int) 2e5 + 10;
vector< pair<int, int> > adj[N];
bool tree_edge[N];
int pe[N], n, m, u, v, x[4], k, c;
int64 value[N];

void dfs(int v) {
	for (int i = 0; i < sz(adj[v]); ++i) {
		int u = adj[v][i].fs, num = adj[v][i].sc;
		if (pe[u] == -1) {
			pe[u] = num;
			tree_edge[num] = true;
			dfs(u);
		}
	}
}

int main() {
	assert(freopen("disconnected.in", "r", stdin));
	assert(freopen("disconnected.out", "w", stdout));
	srand(1729);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i) {
		scanf("%d%d", &u, &v), --u, --v;
		adj[u].pb(mp(v, i)), adj[v].pb(mp(u, i));
	}
	memset(pe, -1, sizeof(pe));
	dfs(0);
	for (int i = 0; i < m; ++i)
		if (!tree_edge[i]) {
			value[i] = 0;
			for (int j = 0; j < 64; ++j)
				value[i] = (value[i] << 1) | (rand() & 1);
		}
	for (int i = 1; i < n; ++i) {
		int64 total = 0;
		for (int j = 0; j < sz(adj[i]); ++j) {
			int e = adj[i][j].sc;
			total ^= value[e];
		}
		value[pe[i]] = total;
	}
	scanf("%d", &k);
	for (int i = 0; i < k; ++i) {
		scanf("%d", &c);
		for (int j = 0; j < c; ++j)
			scanf("%d", &x[j]), --x[j];
		bool disc = false;
		for (int mask = 1; mask < (1 << c); ++mask) {
			int64 total = 0;
			for (int j = 0; j < c; ++j)
				if ((mask >> j) & 1) total ^= value[x[j]];
			if (total == 0) {
				disc = true;
				break;
			}
		}
		printf("%s\n", disc ? "Disconnected" : "Connected");
	}
	return 0;
}