#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
const int N = (int) 3e5 + 10;
const int C1 = 13579, C2 = 97531;
int p[N], q, color[N], in[N], up[N], curt, n, m, u, v;
int64 a, b;
vector< pair<int, int> > adj[N];
vector<int> tree_adj[N];

int dsu_find(int v) {
	return (p[v] == v) ? v : (p[v] = dsu_find(p[v]));
}

void dsu_union(int u, int v) {
	p[dsu_find(u)] = dsu_find(v);
}

void dfs(int v, int pe = -1) {
	color[v] = 1, in[v] = curt++, up[v] = in[v];
	for (int i = 0; i < sz(adj[v]); ++i) {
		int u = adj[v][i].fs, num = adj[v][i].sc;
		if (color[u] == 0) {
			dfs(u, num);
			up[v] = min(up[v], up[u]);
			if ((up[u] < in[v]) && (pe != -1)) dsu_union(pe, num);
		} else if (color[u] == 1) {
			up[v] = min(up[v], in[u]);
			if (pe != -1) dsu_union(pe, num);
		}
	}
	color[v] = 2;
}

void tree_dfs(int v) {
	for (int i = 0; i < sz(tree_adj[v]); ++i) {
		int u = tree_adj[v][i];
		if (u != p[v]) {
			p[u] = v;
			tree_dfs(u);
		}
	}
}

void add_edge(int u, int v) {
	tree_adj[u].pb(v);
	tree_adj[v].pb(u);
}

bool get(int a, int b) {
	if ((a == b) || (p[a] == p[b]) || (a == p[p[b]]) || (b == p[p[a]])) return true;
	int pos = lower_bound(adj[a].begin(), adj[a].end(), mp(b, -1)) - adj[a].begin();
	return ((pos < sz(adj[a])) && (adj[a][pos].fs == b));
}

int main() {
	assert(freopen("code.in", "r", stdin));
	assert(freopen("code.out", "w", stdout));
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i) {
		scanf("%d%d", &u, &v), --u, --v;
		adj[u].pb(mp(v, i)), adj[v].pb(mp(u, i));
		p[i] = i;
	}
	for (int i = 0; i < n; ++i)
		sort(adj[i].begin(), adj[i].end());
	for (int i = 0; i < n; ++i)
		if (color[i] == 0) dfs(i);
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < sz(adj[i]); ++j) {
			int e = adj[i][j].sc;
			add_edge(i, n + dsu_find(e));
		}
	memset(color, 0, sizeof(color));
	memset(p, -1, sizeof(p));
	for (int i = 0; i < n + m; ++i)
		if (color[i] == 0) {
			p[i] = i;
			tree_dfs(i);
		}
	scanf("%d%lld%lld", &q, &a, &b);
	int sum = 0;
	for (int i = 0; i < q; ++i) {
		//printf("%lld %lld\n", a, b);
		sum += (int) get((int) a - 1, (int) b - 1);
		int64 na = b, nb = (C1 * a + C2 * b) % n + 1;
		a = na, b = nb;
	}
	printf("%d\n", sum);
	return 0;
}