#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

const int MAXN = 20000;
const int MAXQ = 500000;

int par[MAXN];
int rnk[MAXN];
int oldRnk[MAXN];
int cc = 0;

void rollback(int x, int y)
{
	if (par[x] == y) {
		rnk[y] = oldRnk[x];
		par[x] = x;
	} else {
		rnk[x] = oldRnk[y];
		par[y] = y;
	}
	cc++;
}

void link(int x, int y)
{
	if (rnk[x] >= rnk[y]) {
		par[y] = x;
		oldRnk[x] = rnk[y];
	} else {
		par[x] = y;
		oldRnk[y] = rnk[x];
	}
	if (rnk[x] == rnk[y]) {
		rnk[x]++;
	}
	cc--;
}

inline int getPar(int x)
{
	return (par[x] == x) ? par[x] : getPar(par[x]);
}

int cnt = 0;
int type[MAXQ], a[MAXQ];
int u[MAXQ], v[MAXQ];
bool res[MAXQ];
int n, m, k;

void
process(int l, int r)
{
	if (l == r - 1) {
		if (type[l] == 2) {
			res[a[l]] = (cc == 1);
		}
	} else {
		int mid = (l + r) / 2;
		vector< pair< int, int > > queries;
		map< int, int > id;
		set< int > other_id;
		for (int i = mid; i < r; ++i) {
			if (type[i] == 2) {
				continue;
			}
			if (id.find(a[i]) == id.end()) {
				id[a[i]] = type[i];
			}
		}
		for (int i = l; i < mid; ++i) {
			if (type[i] == 2) {
				continue;
			}
			other_id.insert(a[i]);
		}
		for (map< int, int >::const_iterator it = id.begin(); it != id.end(); ++it) {
			if (it->second == 1 && other_id.count(it->first) == 0) { // add edge
				int edge_id = it->first;
				int x = u[edge_id], y = v[edge_id];
				x = getPar(x), y = getPar(y);
				if (x != y) {
					queries.push_back(make_pair(x, y));
					link(x, y);
				}
			}
		}
		process(l, mid);
		for (vector< pair< int, int > >::iterator it = queries.begin(); it != queries.end(); ++it) {
			rollback(it->first, it->second);
		}
		queries.clear();
		id.clear();
		other_id.clear();
		for (int i = mid - 1; i >= l; --i) {
			if (type[i] == 2) {
				continue;
			}
			if (id.find(a[i]) == id.end()) {
				id[a[i]] = type[i];
			}
		}
		for (int i = mid; i < r; ++i) {
			if (type[i] == 2) {
				continue;
			}
			other_id.insert(a[i]);
		}
		for (map< int, int >::const_iterator it = id.begin(); it != id.end(); ++it) {
			if (it->second == 0 && other_id.count(it->first) == 0) { // add edge
				int edge_id = it->first;
				int x = u[edge_id], y = v[edge_id];
				x = getPar(x), y = getPar(y);
				if (x != y) {
					queries.push_back(make_pair(x, y));
					link(x, y);
				}
			}
		}
		process(mid, r);
		for (vector< pair< int, int > >::iterator it = queries.begin(); it != queries.end(); ++it) {
			rollback(it->first, it->second);
		}
		queries.clear();
	}
}

int
main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i) {
		scanf("%d%d", &u[i], &v[i]);
		type[cnt] = 0;
		if (u[i] > v[i]) {
			swap(u[i], v[i]);
		}
		a[cnt] = i;
		cnt++;
	}
	scanf("%d", &k);
	for (int id = 0; id < k; ++id) {
		int c;
		scanf("%d", &c);
		int aa[4];
		for (int i = 0; i < c; ++i) {
			scanf("%d", &aa[i]);
			--aa[i];
		}
		for (int i = 0; i < c; ++i) {
			type[cnt] = 1;
			a[cnt] = aa[i];
			cnt++;
		}
		type[cnt] = 2;
		a[cnt] = id;
		cnt++;
		for (int i = 0; i < c; ++i) {
			type[cnt] = 0;
			a[cnt] = aa[i];
			cnt++;
		}
	}
	for (int i = 1; i <= n; ++i) {
		par[i] = i;
		rnk[i] = 0;
	}
	cc = n;
	process(0, cnt);
	for (int i = 0; i < k; ++i) {
		if (res[i]) {
			puts("Connected");
		} else {
			puts("Disconnected");
		}
	}
	return 0;
}