#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = 1e6 + 100;

int n, m;
int a[N], b[N];
int64 c[N];
vector<int> g[N];

int64 get_rand_1() {
	return (rand() << 16) ^ rand();
}

int64 get_rand() {
	return (get_rand_1() << 32) ^ get_rand_1();
}

bool u[N];

void dfs(int v, int pe = -1) {
	if (u[v])
		return ;
	u[v] = true;
	int64 cur = 0;
	for (int i = 0; i < len(g[v]); i++) {
		int e = g[v][i], to = a[e] ^ b[e] ^ v;
		if (e == pe)
			continue;
		dfs(to, e);
		cur ^= c[e];
	}
	if (pe != -1)
		c[pe] = cur;
}

int main() {
#ifdef LOCAL42
#define TASK "A"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	assert(scanf("%d%d", &n, &m) == 2);
	for (int i = 0; i < m; i++) {
		assert(scanf("%d%d", &a[i], &b[i]) == 2);
		a[i]--, b[i]--;
		g[a[i]].pb(i), g[b[i]].pb(i);
	}
	for (int i = 0; i < m; i++) {
		c[i] = get_rand();
	}
	dfs(0);
	bool connected = true;
	for (int i = 0; i < n; i++)
		if (!u[i])
			connected = false;
	if (!connected) {
		int k; assert(scanf("%d", &k) == 1);
		for (int i = 0; i < k; i++) {
			puts("Disconnected");
		}
		return 0;
	}
	int k; assert(scanf("%d", &k) == 1);
	for (int i = 0; i < k; i++) {
		int cc; assert(scanf("%d", &cc) == 1);
		vector<int> e(cc);
		for (int j = 0; j < cc; j++) {
			assert(scanf("%d", &e[j]) == 1);
			e[j]--;
		}
		bool ans = false;
		for (int j = 1; j < (1 << cc); j++) {
			int64 cur = 0;
			for (int k = 0; k < cc; k++)
				if (j & (1 << k))
					cur ^= c[e[k]];
			if (cur == 0) {
				ans = true;
				break;
			}
		}
		if (ans)
			puts("Disconnected");
		else
			puts("Connected");
	}
	return 0;
}
