#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(2e5) + 100;

int cur, cur_col;
bool used[N], good[N];
int tin[N], tout[N], p[2 * N];
vi g[2 * N];
set<int> lst[N];

void dfs1(int v, int pv, bool is_root = false) {
	used[v] = true;
	p[v] = pv;
	tin[v] = tout[v] = cur++;
	int ch = 0;
	for (int i = 0; i < sz(g[v]); ++i) {
		if (g[v][i] == pv) {
			continue;
		}
		if (!used[g[v][i]]) {
			++ch;
			dfs1(g[v][i], v);
			tout[v] = min(tout[v], tout[g[v][i]]);
			if (tout[g[v][i]] >= tin[v]) {
				good[v] = true;
			}
		} else {
			tout[v] = min(tout[v], tin[g[v][i]]);
		}
	}
	if (is_root) {
		good[v] = (ch > 1);
	}
}

inline void add(int v, int u, int c) {
	lst[v].insert(c);
	lst[u].insert(c);
}

void dfs2(int v, int c) {
	for (int i = 0; i < sz(g[v]); ++i) {
		if (g[v][i] == p[v]) {
			continue;
		}
		if (p[g[v][i]] == v) {
			if (good[v] && tout[g[v][i]] >= tin[v]) {
				add(v, g[v][i], cur_col++);
				dfs2(g[v][i], cur_col - 1);
			} else {
				add(v, g[v][i], c);
				dfs2(g[v][i], c);
			}
		} else {
			add(v, g[v][i], c);
		}
	}
}

void dfs3(int v, int pv) {
	p[v] = pv;
	used[v] = true;
	for (int i = 0; i < sz(g[v]); ++i) {
		if (!used[g[v][i]]) {
			dfs3(g[v][i], v);
		} else {
			assert(g[v][i] == pv);
		}
	}
}

inline int check(int a, int b) {
	if (a == b) {
		return 1;
	}
	if (p[a] != -1 && p[a] == p[b]) {
		return 1;
	}
	if (p[a] != -1 && p[p[a]] == b) {
		return 1;
	}
	if (p[b] != -1 && p[p[b]] == a) {
		return 1;
	}
	return 0;
}

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int n, m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; ++i) {
		int a, b;
		scanf("%d %d", &a, &b);
		--a;
		--b;
		g[a].pb(b);
		g[b].pb(a);
	}
	cur = 0;
	cur_col = 0;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs1(i, -1, true);
			dfs2(i, cur_col++);
		}
	}
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		used[i] = false;
	}
	m = cur_col + n;
	for (int i = 0; i < n; ++i) {
		for (set<int>::iterator j = lst[i].begin(); j != lst[i].end(); ++j) {
			g[i].pb(*j + n);
			g[*j + n].pb(i);
		}
	}
	for (int i = 0; i < m; ++i) {
		if (!used[i]) {
			dfs3(i, -1);
		}
	}
	int q, a, b;
	scanf("%d %d %d", &q, &a, &b);
	int ans = 0;
	for (int i = 0; i < q; ++i) {
		ans += check(a - 1, b - 1);
		//cout << a << " " << b << " " << check(a - 1, b - 1) << endl;
		int na = b;
		int nb = (13579LL * a + 97531LL * b) % n + 1;
		a = na;
		b = nb;
	}
	cout << ans << endl;
	return 0;
}
