#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

typedef long long LL;
typedef LL ll;

typedef pair<int, int> pii;
const int kInf = 1000 * 1000 * 1000;

const int MAXN = 16384;
const int MAXM = 131072;

int n, m;
pii edges[MAXM];
int eused[MAXM];

int qsize[MAXM];
int queries[MAXM][4];

int vertex[MAXN];

pii mf[MAXN];
void mfreset() {
  FOR(i, 0, n) {
    mf[i] = pii(i, 1);
  }
}
int mfget(int i) {
  if (mf[i].first == i) return i;
  return mf[i].first = mfget(mf[i].first);
}
void mfmerge(int a, int b) {
  a = mfget(a); b = mfget(b);
  if (a == b) return;
  if (mf[a].second > mf[b].second) swap(a, b);
  mf[a].first = b;
  if (mf[a].second == mf[b].second) {
    mf[b].second++;
  }
}

const int MAXV = 2048;
vector<pii> ve[MAXV];

int vis[MAXV];
int dfs(int v, int q) {
  vis[v] = 1;
  int ans = 1;
  for (int z = 0; z < ve[v].size(); z++) {
    pii u = ve[v][z];
    if (!vis[u.first] && u.second != queries[q][0] && u.second != queries[q][1]
                      && u.second != queries[q][2] && u.second != queries[q][3]) {
      ans += dfs(u.first, q);
    }
  }
  return ans;
}

int main() {
  scanf("%d%d", &n, &m);
  FOR(i, 0, m) {
    scanf("%d%d", &edges[i].first, &edges[i].second);
    edges[i].first--, edges[i].second--;
  }

  int q;
  scanf("%d", &q);
  FOR(i, 0, q) {
    scanf("%d", &qsize[i]);
    FOR(j, 0, qsize[i]) scanf("%d", &queries[i][j]), queries[i][j]--;
    FOR(j, qsize[i], 4) queries[i][j] = -1;
  }

  int cur = 0;
  while (cur < q) {
    int next = min(q, cur + 300);

    FOR(i, 0, m) eused[i] = 1;
    FOR(i, cur, next) FOR(j, 0, qsize[i]) eused[queries[i][j]] = 0;

    mfreset();
    FOR(i, 0, m) if (eused[i]) mfmerge(edges[i].first, edges[i].second);

    int v = 0;
    FOR(i, 0, n) if (mf[i].first == i) vertex[i] = v++;
    FOR(i, 0, n) vertex[i] = vertex[mfget(i)];

    FOR(i, 0, v) {
      ve[i].clear();
    }

    FOR(i, cur, next) FOR(j, 0, qsize[i]) {
      ve[vertex[edges[queries[i][j]].first]].push_back(pii(vertex[edges[queries[i][j]].second], queries[i][j]));
      ve[vertex[edges[queries[i][j]].second]].push_back(pii(vertex[edges[queries[i][j]].first], queries[i][j]));
    }

    FOR(i, cur, next) {
      FOR(j, 0, v) vis[j] = 0;
      if (dfs(0, i) == v) {
        printf("Connected\n");
      } else {
        printf("Disconnected\n");
      }
    }

    cur = next;
  }

  return 0;
}
