#include <stdio.h>

inline int min(int a, int b) {return a < b ? a : b;}
inline int max(int a, int b) {return a > b ? a : b;}

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

const int MOD = 10007;

char visited[MOD * MOD];

int counts[MOD];
int curcounts[MOD];

int cycle[30000];

int main() {
//  int tstart = GetTickCount();

  int n;
  scanf("%d", &n);
  FOR(i, 0, n) {
    int x; scanf("%d", &x);
    counts[x]++;
  }

  int answer = 0;
  FOR(i, 1, MOD) answer = max(answer, counts[i]);
  answer = min(answer, 1);
  answer += counts[0];

  FOR(x, 1, MOD) FOR(y, 1, MOD) {
    if (visited[x + y * MOD]) continue;

    int nc = 1;
    visited[x + y * MOD] = 1;
    cycle[0] = x;
    int cx = y;
    int cy = x * y % MOD;
    while (cx != x || cy != y) {
      visited[cx + cy * MOD] = 1;
      cycle[nc++] = cx;
      int tmp = cx;
      cx = cy;
      cy = tmp * cy % MOD;
    }

    FOR(i, 0, nc) cycle[i + nc] = cycle[i];
    nc *= 2;
    FOR(i, 0, MOD) curcounts[i] = 0;
    FOR(i, 0, nc) curcounts[cycle[i]]++;
    int mx = 1000000;
    FOR(i, 0, MOD) if (curcounts[i]) mx = min(mx, counts[i] / curcounts[i]);
    int base = mx * nc;
    FOR(i, 0, MOD) curcounts[i] = 0;
    int bad = 0;
    int right = 0;
    for (int left = 0; left < nc; left++) {
      while (right - left < nc && bad == 0) {
        int num = cycle[right++];
        if (curcounts[num]++ == counts[num]) bad++;
      }
      answer = max(answer, base + right - 1 - left);
      int num = cycle[left];
      if (--curcounts[num] == counts[num]) bad--;
    }
  }

  printf("%d\n", answer);

//  printf("Time: %.3f", double(GetTickCount() - tstart) * 0.001);

  return 0;
}
