//#include <windows.h>
#include <bitset>
#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)

const int MOD = 10007;
const int aMOD = MOD - 1;

bitset<MOD * MOD> visited;

int recounts[MOD];
int counts[MOD];
int curcounts[MOD];

int unpow[MOD];

int cycle[30000];
int mnext[30000];

int main() {
//  int tstart = GetTickCount();

  int z = 5;
  int zp = 1;
  unpow[1] = 0;
  while (z != 1) {
    unpow[z] = zp;
    z = z * 5 % MOD;
    zp++;
  }

  int n;
  scanf("%d", &n);
  FOR(i, 0, n) {
    int x; scanf("%d", &x);
    counts[x]++;
  }

  int answer = 0;
  FOR(i, 1, MOD) answer = max(answer, counts[i]);
  answer = min(answer, 1);
  answer += counts[0];

  FOR(i, 0, 30000) mnext[i] = i % aMOD;

  memcpy(recounts, counts, sizeof counts);
  FOR(i, 1, MOD) counts[unpow[i]] = recounts[i];

  FOR(x, 0, aMOD) FOR(y, 0, aMOD) {
    if (visited[x + y * MOD]) continue;

    int nc = 1;
    visited[x + y * MOD] = 1;
    cycle[0] = x;
    int cx = y;
    int cy = mnext[x + y];
    while (cx != x || cy != y) {
      visited[cx + cy * MOD] = 1;
      cycle[nc++] = cx;
      int tmp = cx;
      cx = cy;
      cy = mnext[tmp + cy];
    }

    FOR(i, 0, nc) cycle[i + nc] = cycle[i];
    nc *= 2;
    FOR(i, 0, aMOD) curcounts[i] = 0;
    FOR(i, 0, nc) curcounts[cycle[i]]++;
    int mx = 1000000;
    FOR(i, 0, aMOD) if (curcounts[i]) mx = min(mx, counts[i] / curcounts[i]);
    int base = mx * nc;
    FOR(i, 0, aMOD) curcounts[i] = 0;
    int bad = 0;
    int right = 0;
    for (int left = 0; left < nc; left++) {
      while (right - left < nc && bad == 0) {
        int num = cycle[right++];
        if (curcounts[num]++ == counts[num]) bad++;
      }
      answer = max(answer, base + right - 1 - left);
      int num = cycle[left];
      if (--curcounts[num] == counts[num]) bad--;
    }
  }

  printf("%d\n", answer);

//  printf("Time: %.3f", double(GetTickCount() - tstart) * 0.001);

  return 0;
}
