#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

const int X = 1e6 + 100, INF = 1e9;
pair <int, int> eg[X];
int pr[X], sz[X], rk[X], nxt[X], prev_[X], tback[X];
int my_size;
vector <bool> ans;

struct Query
{
    int type;
    int num;
    int g;
    Query(){}
    Query(int type, int num, int g) : type(type), num(num), g(g){}
}lst[X];

vector <Query> stk;

void build_dsu()
{
    for(int i = 0; i < X; i++)
    {
        sz[i] = 1;
        pr[i] = i;
    }
}

int get(int a)
{
    if(a == pr[a]) return a;
    return get(pr[a]);
}

void unite(int a, int b)
{
    a = get(a);
    b = get(b);
    if(a != b)
    {
        if(sz[a] > sz[b])
        {
            stk.push_back(Query(0, a, sz[a]));
            stk.push_back(Query(1, b, 0));
            sz[a] += sz[b];
            pr[b] = a;
        }
        else
        {
            swap(a, b);
            stk.push_back(Query(0, a, sz[a]));
            stk.push_back(Query(1, b, 0));
            sz[a] += sz[b];
            pr[b] = a;
        }
    }
}

void otkat(Query a)
{
    if(a.type == 0)
    {
        sz[a.num] = a.g;
    }
    else
    {
        pr[a.num] = a.num;
    }
}

void dyn_con(int left, int right, int ln)
{
    if(right == left) return;
    if(right - left == 1)
    {
        if(lst[left].type == 2)
        {
            //cout << sz[get(0)] << ' ' << get(0) << '\n';
            if(my_size == sz[get(0)])
            {
                ans.push_back(true);
            }
            else
            {
                ans.push_back(false);
            }
        }
        return;
    }
    int mid = (left + right) / 2;
    for(int i = mid; i < right; i++)
    {
        if(lst[i].type == 1 && prev_[i] < left)
        {
            unite(eg[lst[i].num].first, eg[lst[i].num].second);
        }
    }
    dyn_con(left, mid, stk.size());
    while(stk.size() > ln)
    {
        otkat(stk.back());
        stk.pop_back();
    }
    for(int i = left; i < mid; i++)
    {
        if(lst[i].type == 0 && nxt[i] >= right)
        {
            unite(eg[lst[i].num].first, eg[lst[i].num].second);
        }
    }
    dyn_con(mid, right, stk.size());
    while(stk.size() > ln)
    {
        otkat(stk.back());
        stk.pop_back();
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    build_dsu();
    int n, m, q, cnt = 0;
    cin >> n >> m;
    for(int i = 0; i < m; i++)
    {
        cin >> eg[i].first >> eg[i].second;
        eg[i].first--;
        eg[i].second--;
    }
    my_size = n;
    for(int i  = 0; i < m; i++)
    {
        lst[cnt++] = Query(0, i, 0);
    }
    cin >> q;
    for(int i = 0; i < q; i++)
    {
        int c;
        int zk[4];
        cin >> c;
        for(int j = 0; j < c; j++)
        {
            cin >> zk[j];
            zk[j]--;
        }
        for(int j = 0; j < c; j++)
        {
            lst[cnt++] = Query(1, zk[j], 0);
        }
        lst[cnt++] = Query(2, 0, 0);
        for(int j = 0; j < c; j++)
        {
            lst[cnt++] = Query(0, zk[j], 0);
        }
    }
    for(int i = 0; i < cnt; i++)
    {
        if(lst[i].type == 1)
        {
            prev_[i] = tback[lst[i].num];
            nxt[tback[lst[i].num]] = i;
        }
        if(lst[i].type == 0)
        {
            tback[lst[i].num] = i;
            nxt[i] = INF;
        }
    }
   /* for(int i = 0; i < cnt; i++)
    {
        cout << i << ' ' <<prev_[i] << '\n';
    }
    */
    dyn_con(0, cnt, 0);
    for(int i = 0; i < ans.size(); i++)
    {
        if(ans[i])
        {
            cout << "Connected\n";
        }
        else
        {
            cout << "Disconnected\n";
        }
    }
    return 0;
}
