#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

const int MAXN = 100 * 1000 + 5;
int tin[MAXN], f[MAXN], t, ans;
char used[MAXN];
vector<int> g[MAXN], q[MAXN];

void dfs(int v) {
    used[v] = 1;
    tin[v] = t++;
    f[v] = tin[v];
    for(size_t i = 0; i < g[v].size(); i++) {
        if(used[g[v][i]])
            f[v] = min(f[v], tin[g[v][i]]);
        else {
            dfs(g[v][i]);
            f[v] = min(f[v], f[g[v][i]]);
        }
    }
    for(size_t i = 0; i < q[v].size(); i++) {
        if(used[q[v][i]] != 1)
            continue;
        //cout << v << ' ' << q[v][i] << '\t' << f[v] << ' ' << tin[q[v][i]] << '\n';
        ans += (int)(f[v] <= tin[q[v][i]]);
    }
    used[v] = 2;
}

int main() {
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    int qq, a, b;
    cin >> qq >> a >> b;
    for(int i = 0; i < qq; i++) {
        q[a - 1].push_back(b - 1);
        q[b - 1].push_back(a - 1);
        int newa = b, newb = (13579LL * a + 97531LL * b) % n + 1;
        a = newa;
        b = newb;
    }
    for(int i = 0; i < n; i++)
        if(!used[i])
            dfs(i);
    cout << ans << '\n';
    return 0;
}
