#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <vector>
using namespace std;

typedef long long ll;
typedef pair<int, int> ii;
template <class T> int size(const T &x) { return x.size(); }

const ll INF = 100000000000LL;
//const ll mod = 1LL<<32;

/*
const int ID = 0;
int f(int a, int b) { return a + b; }
struct segment_tree {
    int n; ll *data, *lazy;
    segment_tree() {}
    segment_tree(const vector<int> &arr) {
        n = size(arr);
        printf("%d\n", n);
        data = new ll[4*n];
        printf("X\n");
        lazy = new ll[4*n];
        printf("Y\n");
        for (int i=  0; i < 4*n; i++)
            lazy[i] = INF;
        mk(arr, 0, n-1, 0);
    }
    ll mk(const vector<int> &arr, int l, int r, int i) {
        if (l == r) {
            return data[i] = arr[l];
        }
        int m = (l + r) / 2;
        return data[i] = f(mk(arr, l, m, 2*i+1), mk(arr, m+1, r, 2*i+2));
    }
    ll query(int a, int b) {
        return q(a, b, 0, n-1, 0);
    }
    ll q(int a, int b, int l, int r, int i) {
        propagate(l, r, i);
        if (r < a || b < l) return ID;
        if (a <= l && r <= b) return data[i];
        int m = (l + r) / 2;
        return f(q(a, b, l, m, 2*i+1), q(a, b, m+1, r, 2*i+2));
    }
    //void update(int i, int v) { u(i, v, 0, n-1, 0); }
    //int u(int i, int v, int l, int r, int j) {

    //}

    void range_update(int a, int b, int v) {
        ru(a, b, v, 0, n-1, 0);
    }

    int ru(int a, int b, int v, int l, int r, int i) {
        propagate(l, r, i);
        if (l > r) return ID;
        if (r < a || b > l) return data[i];
        if (l == r)  { data[i] += v; data[i] %= mod; return data[i]; }
        if (a <= l && r <= b) return ((lazy[i] = v) * (r - l + 1) + data[i]) % mod;
        int m = (l + r) / 2;
        return data[i] = f(ru(a, b, v, l, m, 2*i+1),
                ru(a, b, v, m+1, r, 2*i+2));
    }
    void propagate(int l, int r, int i) {
        if (l > r || lazy[i] == INF) return;
        data[i] += lazy[i] * (r - l + 1);
        data[i] %= mod;
        if (l < r) {
            if (lazy[2*i+1] == INF) lazy[2*i+1] = lazy[i];
            else lazy[2*i+1] += lazy[i], lazy[2*i+1] %= mod;
            if (lazy[2*i+2] == INF) lazy[2*i+2] = lazy[i];
            else lazy[2*i+2] += lazy[i], lazy[2*i+2] %= mod;
        }
        lazy[i] = INF;
    }
};
*/

struct fenwick_tree {
    int n;
    unsigned int *data;
    fenwick_tree(int _n = 0)  {
        n = _n;
        data = new unsigned int[n];
        memset(data, 0, n * sizeof(unsigned int));
    }
    void update(int at, unsigned int by) {
        while (at < n) {
            data[at] += by;
            /*if (data[at] >= mod)
                data[at] -= mod;*/
            at |= at + 1;
        }
    }
    unsigned int query(int at) {
        unsigned int res = 0;
        while (at >= 0) {
            res += data[at];
            /*if (res >= mod)
                res -= mod;*/
            at = (at & (at + 1)) - 1;
        } 
        return res;
    }

    unsigned int rsq(int a, int b) {
        unsigned int res = query(b) - query(a-1);
        /*if (res < 0)
            res += mod;
        if (res >= mod)
            res -= mod;*/
        return res;
    }
};

struct fenwick_tree_sq { 
    int n;
    fenwick_tree x1, x0;
    fenwick_tree_sq(int _n) {
        n = _n;
        x1 = fenwick_tree(n);
        x0 = fenwick_tree(n);
    }

    void update(int x, int m, unsigned int c) {
        x1.update(x, m); x0.update(x, c);
    }

    unsigned int query(int x) { return x*x1.query(x) + x0.query(x); }
};

void range_update(fenwick_tree_sq &s, int a, int b, unsigned int k) {
    s.update(a, k, k * (1 - a));
    s.update(b+1, -k, k*b);
}

unsigned int range_query(fenwick_tree_sq &s, int a, int b) {
    unsigned int res = s.query(b) - s.query(a-1);
    /*if (res < 0)
        res += mod;
    if (res >= mod)
        res -= mod;*/
    return res;
}
    

unsigned int a, b, cur = 0;

inline unsigned int nextRand() {
    cur = cur * a + b;
    return cur >> 8;
}

int main() {
    int m, q;
    scanf("%d %d\n", &m, &q);

    scanf("%d %d\n", &a, &b);

    int n = (1<<24) + 100;
    //fenwick_tree_sq st(n);
    //fenwick_tree st(n);

    //vector<pair<int, int> > vs(2*m);
    unsigned int *arr = new unsigned int[n];
    memset(arr, 0, n * sizeof(int));

    for (int i = 0; i < m; i++) {
        unsigned int add = nextRand();
        int l = nextRand();
        int r = nextRand();
        if (l > r) swap(l, r);
        arr[l] += add;
        arr[r+1] -= add;
        //vs[2*i] = ii(l, add);
        //vs[2*i+1] = ii(r+1, -add);
        //vs[i] = make_pair(ii(l, r), add);
        //printf("%d %d %d\n", l, r, add);
        //range_update(st, l, r, add);
        //st->range_update(l, r, add);

        //st.update(l, add);
        //st.update(r+1, -add);
    }

    unsigned int cur = 0;
    int at = 0;
    for (int i = 0; i < n; i++)  {
        cur += arr[i];
        arr[i] = cur;

        /*
        int at = vs[i].first.first,
            nat = i + 1 < n ? vs[i+1].first.second : n;


        int end = min(nat - 1, vs[i].first.second);
        for (int j = at; j <= end; j++) {
            arr[j] += vs[i].second;
        }
        */
    }


        /*
    for (int i = 0; i <= 100000; i++) {
        cout << i << ": " << arr[i] << endl;
    }

    */
    for (int i = 0; i < n; i++) {
        //arr[i] = st.query(i);
        if (i-1 >= 0) {
            arr[i] += arr[i-1];
        }
    }

    unsigned int res = 0;

    for (int i = 0; i < q; i++) {
        int l = nextRand();
        int r = nextRand();
        if (l > r) swap(l, r);
        unsigned int cur = arr[r];
        if (l - 1 >= 0) {
            cur -= arr[l-1];
        }
        //unsigned int cur = range_query(st, l, r);
        //cur = (cur % mod + mod) % mod;
        //cout << cur << endl;
        res += cur;
        /*if (res >= mod)
            res -= mod;*/
    }

    cout << res << endl;

    return 0;
}

