#ifdef SU1
//#define _GLIBCXX_DEBUG
#endif

#include <algorithm>
#include <bitset>
#include <cassert>
#include <climits>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cmath>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <stack>
#include <set>
#include <string>
#include <utility>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define pb(a) push_back(a)
#define mp(x, y) make_pair((x), (y))
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = acosl(ld(-1));
const ld EPS = 1e-9;

const int N = 100 * 1000 + 13;
const int K = 1000 * 1000 + 13;

//const int M = 150;

int n, m;
int a[N], b[N];
int perm[N];

//#define TEST

inline int myrand() { return rand() ^ (rand() << 15); }

inline bool read()
{
	if (scanf("%d%d", &n, &m) != 2) return false;
	forn(i, m)
	{
#ifndef TEST
		assert(scanf("%d%d", &a[i], &b[i]) == 2);
#else
		a[i] = myrand() % n + 1, b[i] = myrand() % n + 1;
#endif
		--a[i], --b[i];
		perm[i] = i;
	}
	random_shuffle(perm, perm + m);
	return true;
}

int dsu[N], cntComp;
pt ch[K];
int szch;

int leader (int v)
{
	if (dsu[v] == v) return v;
	ch[szch++] = mp(v, dsu[v]);
	return dsu[v] = leader(dsu[v]);
}

bool merge (int a, int b)
{
	a = leader(a);
	b = leader(b);
	if (a == b) return false;
	if (rand() & 1) swap(a, b);
	ch[szch++] = mp(a, dsu[a]);
	dsu[a] = b;
	return true;
}

int k;
vector<int> q[N];
int used[N], u;
int edges[N], szedges;
int cnt[N];

inline void solve()
{
	assert(scanf("%d", &k) == 1);
	forn(i, k)
	{
		int cnt;
#ifndef TEST
		assert(scanf("%d", &cnt) == 1);
#else
		cnt = 4;
#endif
		q[i].resize(cnt);
		forn(j, cnt)
		{
#ifndef TEST
			assert(scanf("%d", &q[i][j]) == 1);
#else
			q[i][j] = myrand() % m + 1;
#endif
			q[i][j]--;
		}
	}
	
	const int M = int(0.75 * sqrt(m));
	
	for (int start = 0; start < k; start += M)
	{
		int finish = min(k, start + M);
		u++;
		szedges = 0;
		fore(i, start, finish - 1)
			forn(j, sz(q[i]))
			{
				int num = q[i][j];
				if (used[num] != u)
				{
					cnt[num] = 0;
					used[num] = u;
					edges[szedges++] = num;
				}
				cnt[num]++;
			}
			
		forn(i, n) dsu[i] = i;
		cntComp = n;
		szch = 0;
		forn(i, m)
		{
			int idx = perm[i];
			if (used[idx] == u) continue;
			if (merge(a[idx], b[idx])) cntComp--;
		}
		szch = 0;
		
		fore(i, start, finish - 1)
		{
			u++;
			forn(j, sz(q[i])) used[q[i][j]] = u;
			
			int curCnt = cntComp;
			
			forn(j, szedges)
			{
				int num = edges[j];
				if (used[num] == u) continue;
				if (cnt[num] == 0)
				{
					swap(edges[j], edges[szedges - 1]);
					j--, szedges--;
					continue;
				}
				if (merge(a[num], b[num])) curCnt--;
				if (curCnt == 1) break;
			}
			
			if (curCnt == 1) puts("Connected");
			else puts("Disconnected");
			
			ford(j, szch) dsu[ch[j].ft] = ch[j].sc;
			szch = 0;
			
			forn(j, sz(q[i]))
			{
				int num = q[i][j];
				if (--cnt[num] == 0)
				{
					if (merge(a[num], b[num])) cntComp--;
				}
			}
			szch = 0;
		}
	}
}

int main()
{
#ifdef SU1
	assert(freopen("input.txt", "rt", stdin));
//	assert(freopen("output.txt", "wt", stdout));
#endif

	cout << fixed << setprecision(10);
	cerr << fixed << setprecision(5);

	assert(read());
	solve();
	
#ifdef SU1
	cerr << "=== TIME : " << clock() << " ===" << endl;
#endif
	return 0;
}
