#ifdef SU1
#define _GLIBCXX_DEBUG
#endif

#include <algorithm>
#include <bitset>
#include <cassert>
#include <climits>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cmath>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <stack>
#include <set>
#include <string>
#include <utility>
#include <vector>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define pb(a) push_back(a)
#define mp(x, y) make_pair((x), (y))
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = acosl(ld(-1));
const ld EPS = 1e-9;

const int N = 200500;
int n, m;
vector<int> g[N];
int qcnt, A, B;

set<pt> ex;

inline bool read()
{
	assert(scanf("%d%d", &n, &m) == 2);
	forn(i, m) {
		int a, b;
#ifndef SU1dhjsgf
		assert(scanf("%d%d", &a, &b) == 2);
		a--; b--;
#else
//		a = rand() % n, b = rand() % n;
//		if (a == b || ex.count(pt(a, b))) { i--; continue; }
		a = (i + 1) % n; b = i;
//		ex.insert(pt(a, b));
//		ex.insert(pt(b, a));
#endif
		g[a].pb(b);
		g[b].pb(a);
	}
	assert(scanf("%d%d%d", &qcnt, &A, &B) == 3);
	return true;
}

bool used[N];
int tin[N], fup[N], curt = 0;
map<pt, int> colE;
map<pt, vector<pt> > gE;
int nCol = 0;
void dfs(int v, int p = -1) {
	tin[v] = fup[v] = curt++;
	forn(i, sz(g[v])) {
		int to = g[v][i];
		if (to == p) continue;
		bool same = false;
		if (used[to]) {
			fup[v] = min(fup[v], tin[to]);
			if (p != -1 && tin[to] <= tin[p])
				same = true;
		} else {
			used[to] = true;
			dfs(to, v);
			fup[v] = min(fup[v], fup[to]);
			if (p != -1 && fup[to] <= tin[p])
				same = true;
		}
    		if (same) {
    			gE[pt(v, to)].pb(pt(v, p));
    			gE[pt(v, p)].pb(pt(v, to));
    		}
	}
}

bool isCut[N];
int col[N];

vector<int> es[N];
int* qs[N];

int used2[N], cused2;
map<pt,bool> usedE;
void dfsE(pt v) {
	if (usedE[v]) return;
	usedE[v] = true;
	forn(i, sz(gE[v])) {
		pt to = gE[v][i];
		colE[to] = colE[v];
		dfsE(to);
	}
}

vector<int> gcol[N];
bool usedEs[N];
int pr[N];
void dfsEs(int v, int p = -1) {
	if (usedEs[v]) return;
	usedEs[v] = true;
	pr[v] = p;
	forn(i, sz(gcol[v])) {
		dfsEs(gcol[v][i], v);
	}
}

int szqs[N];
int vals[25000010];

inline void solve()
{
	forn(v, n)
		forn(i, sz(g[v])) {
			int to = g[v][i];
			gE[pt(v, to)].pb(pt(to, v));
		}
	forn(v, n) {
		if (used[v]) continue;
		used[v] = true;
		dfs(v);
	}
	for (map<pt,vector<pt> >::iterator it = gE.begin(); it != gE.end(); ++it) {
/*		if (it->x.x < it->x.y) {
    		forn(i, sz(it->y)) {
    			cerr << it->x.x << ' ' << it->x.y << " to " << it->y[i].x << ' ' << it->y[i].y << endl;
    		}
    	}*/
		pt v = it->ft;
		if (!usedE[v]) {
//			cerr << "ST! " << v.x << ' ' << v.y << endl;
			colE[v] = nCol++;
			dfsE(v);
		}
	}
//	cerr << clock() << endl;
/*	for(map<pt,vector<pt> >::iterator it = gE.begin(); it != gE.end(); ++it) {
		if (it->x.x < it->x.y)
			cerr << it->x.x + 1 << ' ' << it->x.y + 1 << " = " << colE[it->x] << endl;
	}*/
	forn(v, n) {
		set<int> cols;
		forn(i, sz(g[v])) {
			int to = g[v][i];
			col[v] = col[to] = colE[pt(v, to)];
			cols.insert(col[v]);
		}
		if (sz(cols) > 1) {
			isCut[v] = true;
		}
	}
	forn(v, n) {
		if (g[v].empty())
			col[v] = nCol++;
	}
	int cutStart = nCol;
	forn(v, n) {
		if (isCut[v]) {
//			cerr << "cut " << v + 1 << " = " << nCol << endl;
			col[v] = nCol++;
		}
	}
	forn(v, n) {
		//cerr << "col[" << v << "] = " << col[v] << endl;
	}
	forn(v, n) {
		if (!isCut[v]) continue;
		forn(i, sz(g[v])) {
			int to = g[v][i];
			int a = col[v], b = colE[pt(v, to)];
//			cerr << "edge " << a << ' ' << b << endl;
			es[a].pb(b);
			es[b].pb(a);
			gcol[a].pb(b);
			gcol[b].pb(a);
		}
	}
	forn(i, nCol) {
		dfsEs(i);
	}
	//cerr << clock() << endl;
	int oA = A, oB = B;
	forn(i, qcnt) {
		//cerr << "QUERY " << A << ' ' << B << endl;
		int a = col[A - 1], b = col[B - 1];
		szqs[a]++;//qs[a].pb(b);
	
		int oldA = A;
		A = B;
		B = int((13579 * 1LL * oldA + 97531 * 1LL * B) % n + 1);
		vals[i] = B;
	}
	A = oA, B = oB;
	forn(v, nCol) {
		qs[v] = new int[szqs[v]];
		szqs[v] = 0;
	}
	forn(i, qcnt) {
		//cerr << "QUERY " << A << ' ' << B << endl;
		int a = col[A - 1], b = col[B - 1];
		qs[a][szqs[a]++] = b;
	
		int oldA = A;
		A = B;
		B = vals[i];
	}
	
	//cerr << clock() << endl;
	
	int ans = 0;
	forn(v, nCol) {
		cused2++;
		forn(i, sz(es[v]))
			used2[es[v][i]] = cused2;
		forn(i, szqs[v]) {
			int a = v, b = qs[v][i];
			bool good2 = false;
			if (a >= cutStart && b >= cutStart) {
				if (pr[a] == pr[b]) good2 = true;
				if (pr[b] != -1 && pr[pr[b]] == a) good2 = true;
				if (pr[a] != -1 && pr[pr[a]] == b) good2 = true;
			}
			if (used2[qs[v][i]] == cused2 || v == qs[v][i] || good2) {
				//cerr << "OK FOR " << qs[v][i].y << endl;
				ans++;
			}
		}
	}
	printf("%d\n", ans);
}

int main()
{
#ifdef SU1
	assert(freopen("input.txt", "rt", stdin));
//	assert(freopen("output.txt", "wt", stdout));
#endif

	cout << fixed << setprecision(10);
	cerr << fixed << setprecision(5);

	assert(read());
	solve();
	
#ifdef SU1
	cerr << "=== TIME : " << clock() << " ===" << endl;
#endif
	return 0;
}
