#include <iostream>
#include <cstdio>
#include <cassert>
#include <vector>
#include <algorithm>
#include <memory.h>

using namespace std;

const int maxn = 1 << 17;

int n, m;
int u[maxn], v[maxn];
vector<int> e[maxn], a[maxn];
bool vis[maxn], isPoint[maxn];
int in[maxn], out[maxn], cnt;
int cur;
int c[maxn];

int go(int id, int cur) {
	if (u[id] == cur) return v[id];
	return u[id];
}

void dfs(int v, int p) {
	vis[v] = 1;
	in[v] = out[v] = cnt++;
	int ch = 0;
	for (int i = 0; i < (int)e[v].size(); i++) {
		int to = go(e[v][i], v);
		if (to == p) continue;
		if (vis[to]) {
			out[v] = min(out[v], in[to]);
		} else {
			ch++;
			dfs(to, v);
			out[v] = min(out[v], out[to]);
			if (p != -1 && out[to] >= in[v]) {
				isPoint[v] = 1;
			}
		}
	}
	if (p == -1) isPoint[v] = ch > 1;
}

void dfs2(int v, int color) {
	vis[v] = 1;
	for (int i = 0; i < (int)e[v].size(); i++) {
		int to = go(e[v][i], v);
		if (vis[to]) {
			if (c[e[v][i]] == -1) {
				c[e[v][i]] = color;
			} else {
				//assert(c[e[v][i]] == color || );
			}
		} else {
			if (isPoint[v] && out[to] >= in[v]) {
				c[e[v][i]] = ++cur;
				dfs2(to, cur);
			} else {
				c[e[v][i]] = color;
				dfs2(to, color);
			}
		}
	}
}

int f(int i, int j) {
	if (a[i].size() < a[j].size()) swap(i, j);
	
	bool res = 0;
	if (a[j].size() * 15 < a[i].size()) {
		for (int k = 0; k < (int)a[j].size(); k++) {
			if (binary_search(a[i].begin(), a[i].end(), a[j][k])) {
				res = 1;
				break;
			}
		}
	} else {
		int l = 0, r = 0;
		while (l < (int)a[i].size() && r < (int)a[j].size()) {
			if (a[i][l] == a[j][r]) {
				res = 1;
				break;
			}
			if (a[i][l] < a[j][r]) {
				l++;
			} else {
				r++;
			}
		}
	}
	return res;
}

int main() {
	freopen("code.in", "r", stdin);

	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++) {
		scanf("%d%d", &u[i], &v[i]);
		e[u[i]].push_back(i);
		e[v[i]].push_back(i);
	}
	for (int i = 1; i <= n; i++) {
		if (!vis[i]) {
			dfs(i, -1);
		}
	}
	memset(vis, 0, sizeof(vis));
	memset(c, -1, sizeof(c));
	for (int i = 1; i <= n; i++) {
		if (!vis[i]) {
			dfs2(i, cur);
		}
	}
	for (int i = 0; i < m; i++) {
		a[u[i]].push_back(c[i]);
		a[v[i]].push_back(c[i]);
	}
	for (int i = 1; i <= n; i++) {
		sort(a[i].begin(), a[i].end());
		a[i].resize(unique(a[i].begin(), a[i].end()) - a[i].begin());
	}

	int k, a1, b1;
	int ans = 0;
	scanf("%d%d%d", &k, &a1, &b1);
	for (int i = 0; i < k; i++) {
		ans += f(a1, b1);
		int a2 = b1;
		int b2 = (13579LL * a1 + 97531 * b1) % n + 1;
		swap(a1, a2);
		swap(b1, b2);
	}
	cout << ans << endl;

	return 0;
}