#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
using namespace std;


const int maxn = 2e5 + 100;

const int maxN = 2 * maxn;
vector <int> G[maxN];
bool USED[maxN];
int par[maxN];
int h[maxN];


vector <int> g[maxn];
int timer = 146;
int used[maxn];
int goTo[maxn];
vector <vector <int> > blocks;

int conId[maxn];
int conSz;

int color[maxn];
vector <int> st;

void addComp(int sz)
{
	vector <int> v;
	while ( (int) st.size() > sz)
	{
		v.push_back(st.back() );
		st.pop_back();
	}
	blocks.push_back(v);
}


int dfs(int v)
{
	if ( (int) g[v].size() == 0)
	{
		st.clear();
		st.push_back(v);
		addComp(0);
		return 0;
	}

	used[v] = timer++;
	goTo[v] = used[v];

	for (int i = 0; i < (int) g[v].size(); i++)
	{
		int nv = g[v][i];
		if (used[nv] )
		{
			goTo[v] = min(goTo[v], used[nv] );
			continue;
		}
		int noTouch = (int) st.size();
		int x = dfs(nv);
		if (x >= used[v] )
		{
			st.push_back(v);
			addComp(noTouch);
			conId[v] = ++conSz;
		}
		goTo[v] = min(goTo[v], x);
	}
	st.push_back(v);
	return goTo[v];
}

int getV(int t, int v)
{
	if (t == 0)
		return v;
	return (int) blocks.size() + conId[v] - 1;
}

void dfsPar(int v, int cp, int ch)
{
	USED[v] = true;
	par[v] = cp;
	h[v] = ch;
	for (int i = 0; i < (int) G[v].size(); i++)
	{
		int nv = G[v][i];
		if (nv == cp)
			continue;
		dfsPar(nv, v, ch + 1);
	}
}

int getVV(int a)
{
	if (conId[a] != 0)
		return getV(1, a);
	return getV(0, color[a] );
}

int solve(int a, int b)
{
//	printf("%d %d\n", a, b);
	int A = getVV(a);
	int B = getVV(b);
	if (conId[a] == 0 && conId[b] == 0)
		return (A == B ? 1 : 0);
	if (A == B)
		return 1;
	for (int it = 0; it < 2; it++)
	{
		if (h[A] >= h[B] )
			A = par[A];
		else
			B = par[B];
		if (A == -1 || B == -1)
			return 0;
		if (A == B)
			return 1;
	}
//	printf("no\n");
	return 0;
}

int main()
{
	freopen("code.in", "r", stdin);
	freopen("code.out", "w", stdout);

	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++)
	{
		int a, b;
		scanf("%d%d", &a, &b);
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < n; i++)
	{
		if (used[i] )
			continue;
		dfs(i);
	}
	int N = (int) blocks.size() + conSz;
	for (int i = 0; i < (int) blocks.size(); i++)
	{
		for (int j = 0; j < (int) blocks[i].size(); j++)
		{
			int v = blocks[i][j];
			if (conId[v] )
			{
				int A = getV(0, i);
				int B = getV(1, v);
//				printf("%d <-> %d\n", A, B);
				G[A].push_back(B);
				G[B].push_back(A);
			}
			else
			{
				color[v] = i;
			}
		}
//		printf("\n");
	}
	
	for (int i = 0; i < N; i++)
	{
		if (USED[i] )
			continue;
		dfsPar(i, -1, 0);
	}

	int q, ca, cb;
	scanf("%d%d%d", &q, &ca, &cb);
	int ans = 0;
	for (int i = 0; i < q; i++)
	{
		ans += solve(ca - 1, cb - 1);
		int na = cb;
		int nb = (13579 * 1LL * ca + 97531 * 1LL * cb) % n + 1;
		ca = na;
		cb = nb;
	}
	printf("%d\n", ans);

	return 0;
}
