#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>

#define TASK "task"
#define iters 1000

typedef long long ll;
typedef long double ld;

using namespace std;

vector<int> edges[10000];
set< pair<int, int> > trees[iters];
bool disc[10000];
vector< pair<int, int> > edgePairs;
set< pair<int, int> > notUsed;

void dfs (int v, int iter)
{
	disc[v] = true;

	if (edges[v].size() < 100)
		random_shuffle(edges[v].begin(), edges[v].end());
	else
		random_shuffle(edges[v].begin(), edges[v].begin() + 100);

	for (int i = 0; i < edges[v].size(); i++)
	{
		if (!disc[edges[v][i]])
		{
			dfs(edges[v][i], iter);
			trees[iter].insert(make_pair(v, edges[v][i]));
			trees[iter].insert(make_pair(edges[v][i], v));
		}
	}
}

void dfsSmall (int v)
{
	disc[v] = true;

	for (int i = 0; i < edges[v].size(); i++)
	{
		if (!disc[edges[v][i]])
			dfsSmall(edges[v][i]);
	}
}

int main() {
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);

	srand(time(NULL));

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		a--; b--;

		edgePairs.push_back(make_pair(a, b));
		edges[a].push_back(b);
		edges[b].push_back(a);
	}

	for (int i = 0; i < iters; i++)
	{
		memset(disc, 0, sizeof(disc));
		dfs(rand() % n, i);
	}

	/*for (int i = 0; i < 5; i++)
	{
		cout << "tree " << i + 1 << endl;
		set< pair<int, int> >::iterator it;
		for (it = trees[i].begin(); it != trees[i].end(); it++)
		{
			cout << (*it).first + 1 << ' ' << (*it).second + 1 << endl;
		}
	}*/

	int k;
	cin >> k;

	for (int i = 0; i < k; i++)
	{
		int c;
		cin >> c;

		vector<int> rem;
		for (int j = 0; j < c; j++)
		{
			int p;
			cin >> p;
			p--;
			rem.push_back(p);
		}

		bool isTree = false;
		for (int j = 0; j < iters; j++)
		{
			bool good = true;
			for (int k = 0; k < rem.size(); k++)
			{
				if (trees[j].find(edgePairs[rem[k]]) != trees[j].end())
				{
					good = false;
					break;
				}
			}
			if (good)
			{
				isTree = true;
				break;
			}
		}

		if (isTree)
			cout << "Connected" << endl;
		else
			cout << "Disconnected" << endl;
	}
	
	return 0;
}