#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "code"
#define MAXN 100100

int n, m;




vector<vector<int> > g;
vector<int> used;
vector<int> fup, tin;
int timer = 0;

vector<int> ans;
void dfs(int v, int p = -1)
{
    used[v] = 1;
    fup[v] = tin[v] = ++timer;
    for (int i = 0; i < g[v].size(); i++)
    {
        int to = g[v][i];
        if (to == p)
            continue;

        if (!used[to])
        {
            dfs(to, v);
            fup[v] = min(fup[v], fup[to]);
        }
        else
            fup[v] = min(fup[v], tin[to]);

        if (fup[to] > tin[v])
        {
            int a1 = to, a2 = v;
            if (a1 > a2)
                swap(a1, a2);
            if (ans[a1] == -1)
                ans[a1] = a2;
            else
                ans[a2] = a1;
        }
    }
}

vector<vector<int> > g2;
vector<int> color;
int cl = 0;

void dfs2(int v)
{
    color[v] = cl;
    for (int i = 0; i < g2[v].size(); i++)
    {
        int to = g2[v][i];
        if (color[to] == -1)
            dfs2(to);
    }
}

void process(){
    int a, b, q;
    scanf("%d%d%d", &q, &a, &b);
    int res = 0;
    for (int i = 1; i <= q; i++)
    {
        //cout << a - 1 << " " << b - 1 << endl;
        if (color[a - 1] == color[b - 1] || ans[a - 1] == b - 1 || ans[b - 1] == a - 1)
            res++;
        int temp = a;
        a = b;
        b = (LL(13579) * temp + LL(97531) * b) % n + 1;
    }

    printf("%d\n", res);
}


void solve()
{
    scanf("%d%d", &n, &m);
    int u, v;
    g.resize(n);
    used.resize(n);
    vector<pii> ed;
    for (int i = 0; i < m; i++){
        scanf("%d%d", &u, &v);
        u--;v--;
        g[u].pb(v);
        g[v].pb(u);
        if (u > v)
            swap(u, v);
        ed.pb(mp(u, v));
    }

    ans.resize(n, -1);
    fup.resize(n);tin.resize(n);
    for (int i = 0; i < n; i++)
    {
        if (!used[i])
            dfs(i);
    }

    g2.resize(n);
    color.resize(n, -1);
    for (int i = 0; i < m; i++)
    {
        int u = ed[i].X;
        int v = ed[i].Y;
        if (ans[u] != v && ans[v] != u)
        {
            g2[u].pb(v);
            g2[v].pb(u);
        }
    }

    for (int i = 0; i < n; i++)
    {
        if (color[i] == -1)
        {
            dfs2(i);
            cl++;
        }
    }
    process();
}
 
int main()
{
   // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
   //freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif